package body Dates is
   subtype Month_30d is Month_T with Predicate => Month_30d in 4 | 6 | 9 | 11;
   subtype Month_31d is Month_T with Predicate => Month_31d in 1 | 3 | 5 | 7 | 8 | 10 | 12;

   procedure Put_Image
      (Output : in out Ada.Strings.Text_Buffers.Root_Buffer_Type'Class; D : Date_T) is

       function Image_No_WS (N : Natural) return String is
          S : constant String := N'Image;
       begin
          return S (S'First + 1 .. S'Last);
       end Image_No_WS;
   begin
      Output.Put (Image_No_WS (D.Y));
      Output.Put ("/");
      Output.Put (Image_No_WS (D.M));
      Output.Put ("/");
      Output.Put (Image_No_WS (D.D));
   end Put_Image;

   function Leap_Year (Y : Year_T) return Boolean
      is (Y mod 4 = 0 and (Y mod 100 /= 0 or Y mod 400 = 0));

   function Valid (D : Date_T) return Boolean is
   begin
      return D.D <= (
         case D.M is
         when Month_30d => 30,
         when Month_31d => 31,
         when 2 => (if Leap_Year (D.Y) then 29 else 28)
         );
   end Valid;
end Dates;
