with Ada.Strings.Text_Buffers;

package Dates is
   subtype Year_T is Integer range 0 .. 3000;
   subtype Month_T is Integer range 1 .. 12;
   subtype Day_Of_Month_T is Integer range 1 .. 31;

   subtype Year_Range_T is Positive range 1 .. 4;
   subtype Month_Range_T is Positive range 6 .. 7;
   subtype Day_Of_Month_Range_T is Positive range 9 .. 10;

   type Date_T is record
      Y : Year_T;
      M : Month_T;
      D : Day_Of_Month_T;
   end record
      with Put_Image => Put_Image;

   function Make (S : String) return Date_T
      is (
         Y => Year_T'Value (S (Year_Range_T)),
         M => Month_T'Value (S (Month_Range_T)),
         D => Day_Of_Month_T'Value (S (Day_Of_Month_Range_T))
         );

   procedure Put_Image
      (Output : in out Ada.Strings.Text_Buffers.Root_Buffer_Type'Class; D : Date_T);

   function Valid (D : Date_T) return Boolean;

   subtype Valid_Date_T is Date_T with Predicate => Valid (Valid_Date_T);

end Dates;
